%This M-Function was created automatically by PSG Toolbox.
%
%Input variables:
%
%Inputs                             PSG Type    PSG Object                    Location in Problem Statement                                                           Class
%matrix_xfirst_scp_data             data        matrix_xfirst_scp             avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%matrix_xfirst_scp_vars             vars        matrix_xfirst_scp             avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%matrix_of_scenarios_scp_75_data    data        matrix_of_scenarios_scp_75    avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%matrix_of_scenarios_scp_75_vars    vars        matrix_of_scenarios_scp_75    avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%pmatrix_subproblem_scp_data        data        pmatrix_subproblem_scp        avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    double
%pmatrix_subproblem_scp_vars        vars        pmatrix_subproblem_scp        avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))    cell
%pmatrix_xmulti_scp_data            data        pmatrix_xmulti_scp            linearmulti(pmatrix_xmulti_scp)                                                         double
%pmatrix_xmulti_scp_vars            vars        pmatrix_xmulti_scp            linearmulti(pmatrix_xmulti_scp)                                                         cell
%vector_l_scp_data                  data        vector_l_scp                  Constraint: >= vector_l_scp, <= vector_u_scp                                            double
%vector_u_scp_data                  data        vector_u_scp                  Constraint: >= vector_l_scp, <= vector_u_scp                                            double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = supply_chain_function(matrix_xfirst_scp_data,matrix_xfirst_scp_vars,matrix_of_scenarios_scp_75_data,matrix_of_scenarios_scp_75_vars,pmatrix_subproblem_scp_data,pmatrix_subproblem_scp_vars,pmatrix_xmulti_scp_data,pmatrix_xmulti_scp_vars,vector_l_scp_data,vector_u_scp_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_xfirst_scp',matrix_xfirst_scp_data,matrix_xfirst_scp_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_of_scenarios_scp_75',matrix_of_scenarios_scp_75_data,matrix_of_scenarios_scp_75_vars,[],[]);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_subproblem_scp',pmatrix_subproblem_scp_vars,pmatrix_subproblem_scp_data);
count = count+1;
iargstruc_arr(count) = object_pack('pmatrix_xmulti_scp',pmatrix_xmulti_scp_vars,pmatrix_xmulti_scp_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_l_scp',vector_l_scp_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_u_scp',vector_u_scp_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'avg(recourse(matrix_xfirst_scp, pmatrix_subproblem_scp, matrix_of_scenarios_scp_75))',...
'Constraint: >= vector_l_scp, <= vector_u_scp',...
'linearmulti(pmatrix_xmulti_scp)',...
'Box: >= 0, <= 1e+13',...
'Solver: cargrb, precision = 6',...
' ');
%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

